// ****************************************************************************
//  vfd.c                           (C) 1992-2003 Christophe de Dinechin (ddd) 
//                                                            VFD800 project 
// ****************************************************************************
// 
//   File Description:
// 
//    Control functions for the VFD800 (Noritake)
// 
// 
// 
// 
// 
// 
// 
// 
// ****************************************************************************
// This document is confidential.
// Do not redistribute without written permission
// ****************************************************************************
// * File       : $RCSFile$
// * Revision   : $Revision$
// * Date       : $Date$
// ****************************************************************************

#include "vfd.h"
#include <time.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/io.h>



// ============================================================================
// 
//   High-level functions
// 
// ============================================================================

int VFD_Init()
// ----------------------------------------------------------------------------
//   Initialize the VFD
// ----------------------------------------------------------------------------
{
    int error = 0;
    int n;

    if (ioperm(CONTROLPORT,1,1))
    {
         fprintf(stderr, "Couldn't get the port at %x\n", CONTROLPORT);
         return 1;
    }
    if (ioperm(DATAPORT,1,1))
    {
         fprintf(stderr, "Couldn't get the port at %x\n", DATAPORT);
         return 1;
    };

    // Start 800 init sequence
    VFD_Command (INIT800A);
    usleep (2 MS);

    for(n = 0; n < 8; n++)
    {
         VFD_Command(INIT800B);
         usleep (2 MS);
         VFD_Command(INIT800C(n));
         usleep (2 MS);
         VFD_Data(INIT800D);
         usleep (2 MS);
    }
    
    // Initialize for us
    VFD_EnableScreen(1, 1);     // Enable both screens
    VFD_Command(ORON);          // OR both screens
    VFD_Command(HSHIFT);        // Set horizontal shift
    VFD_Command(0);             // = 0
    VFD_Command(VSHIFT);        // Set vertical shift
    
    VFD_Command(AUTOINCX);      // Auto-increment X by default
    VFD_Command(SETX);          // Set X coordinate
    VFD_Command(0x0);           // to 0
    VFD_Command(SETY);          // Set Y coordinate
    VFD_Command(0);             // to 0

    VFD_LoadGlyphs(VFD_ProportionalFont);
    return 0;
}


void VFD_LoadGlyphs (char *glyphs)
// ----------------------------------------------------------------------------
//    Load a glyphs table
// ----------------------------------------------------------------------------
{
    int c;

    // Init glyphs
    for (c = 0; c < 256; c++)
    {
         char *base = glyphs;
         char width = *glyphs++;
         char height = *glyphs++;
         VFD_Font[c] = base;
         glyphs += width * height;
    }
}


void VFD_EnableScreen(int screen0, int screen1)
// ----------------------------------------------------------------------------
//   Enable the given screen layers
// ----------------------------------------------------------------------------
{
    int command = 0x20 | ((screen0<<2) + (screen1<<3));
    VFD_Command(command);
    VFD_Brightness(1.0);
}


void VFD_Brightness(float brightness)
// ----------------------------------------------------------------------------
//   Select the brightness
// ----------------------------------------------------------------------------
{
    if (brightness > 1.0)
        brightness = 1.0;
    if (brightness < 0.0)
        brightness = 0.0;

    VFD_Command(0x40 | (15 - (int) (15 * brightness)));
}


void VFD_SetX(int X)
// ----------------------------------------------------------------------------
//   Move cursor on X axis
// ----------------------------------------------------------------------------
{
    VFD_Command(SETX);
    VFD_Command(X);
}


void VFD_SetY(int Y)
// ----------------------------------------------------------------------------
//   Move cursor on X axis
// ----------------------------------------------------------------------------
{
    VFD_Command(SETY);
    VFD_Command(Y);
}


void VFD_SetXY(int X, int Y)
// ----------------------------------------------------------------------------
//   Move cursor on X axis
// ----------------------------------------------------------------------------
{
    VFD_SetX(X); VFD_SetY(Y);
}


void VFD_Char(char c)
// ----------------------------------------------------------------------------
//    Emit a single character
// ----------------------------------------------------------------------------
{
    char *glyph = VFD_Font[(unsigned char) c];
    int col, row;
    int width = *glyph++;
    int height = *glyph++;
    if (height == 1)
    {
         for (col = 0; col < width; col++)
              VFD_Data(*glyph++);
    }
    else
    {
         // ???
    }
}


void VFD_Text(char *text)
// ----------------------------------------------------------------------------
//   Emit the text at current position
// ----------------------------------------------------------------------------
{
    char c;
    while (c = *text++)
        VFD_Char(c);
}



// ============================================================================
// 
//    Low-level functions
// 
// ============================================================================

void VFD_Command(int command)
// ----------------------------------------------------------------------------
//   Send the given command to the VFD
// ----------------------------------------------------------------------------
{
    // Set C/D to C (control)
    outb(0x0, CONTROLPORT);

    // Write data port
    outb(command, DATAPORT);

    // Set /WR
    outb (0x01, CONTROLPORT);

    // Reset /WR
    outb (0x00, CONTROLPORT);
}


void VFD_Data(int data)
// ----------------------------------------------------------------------------
//   Send the given command to the VFD
// ----------------------------------------------------------------------------
{
    // Set C/D to D (data)
    // outb(0x08, CONTROLPORT);

    // Write data port
    outb(data, DATAPORT);

    // Set /WR
    outb (0x09, CONTROLPORT);

    // Reset /WR
    outb (0x08, CONTROLPORT);
}


char *VFD_Font[256] = { 0 };

char VFD_MonospacedFont[] =
// ----------------------------------------------------------------------------
//   The default monospaced font for the VFD
// ----------------------------------------------------------------------------
{
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x00   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x01   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x02   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x03   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x04   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x05   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x06   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x07   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x08   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x09   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x0A   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x0B   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x0C   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x0D   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x0E   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x0F   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x10   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x11   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x12   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x13   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x14   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x15   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x16   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x17   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x18   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x19   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x1A   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x1B   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x1C   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x1D   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x1E   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x1F   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x20   */
     6, 1,      0x00, 0x00, 0x5F, 0x00, 0x00, 0x00, /* 0x21 ! */
     6, 1,      0x00, 0x0E, 0x00, 0x0E, 0x00, 0x00, /* 0x22 " */
     6, 1,      0x14, 0x7F, 0x14, 0x7F, 0x14, 0x00, /* 0x23 # */
     6, 1,      0x24, 0x2A, 0x7F, 0x2A, 0x12, 0x00, /* 0x24 $ */
     6, 1,      0x46, 0x26, 0x10, 0x68, 0x64, 0x00, /* 0x25 % */
     6, 1,      0x36, 0x49, 0x55, 0x22, 0x50, 0x00, /* 0x26 & */
     6, 1,      0x00, 0x0A, 0x06, 0x00, 0x00, 0x00, /* 0x27 ' */
     6, 1,      0x00, 0x1C, 0x22, 0x41, 0x00, 0x00, /* 0x28 ( */
     6, 1,      0x00, 0x00, 0x41, 0x22, 0x1C, 0x00, /* 0x29 ) */
     6, 1,      0x28, 0x10, 0x7C, 0x10, 0x28, 0x00, /* 0x2A * */
     6, 1,      0x08, 0x08, 0x3E, 0x08, 0x08, 0x00, /* 0x2B + */
     6, 1,      0x00, 0x00, 0x50, 0x30, 0x00, 0x00, /* 0x2C , */
     6, 1,      0x08, 0x08, 0x08, 0x08, 0x08, 0x00, /* 0x2D - */
     6, 1,      0x00, 0x60, 0x60, 0x00, 0x00, 0x00, /* 0x2E . */
     6, 1,      0x40, 0x20, 0x10, 0x08, 0x04, 0x00, /* 0x2F / */
     6, 1,      0x3E, 0x51, 0x49, 0x45, 0x3E, 0x00, /* 0x30 0 */
     6, 1,      0x00, 0x42, 0x7F, 0x40, 0x00, 0x00, /* 0x31 1 */
     6, 1,      0x42, 0x61, 0x51, 0x49, 0x46, 0x00, /* 0x32 2 */
     6, 1,      0x21, 0x41, 0x45, 0x4B, 0x31, 0x00, /* 0x33 3 */
     6, 1,      0x18, 0x14, 0x12, 0x7F, 0x10, 0x00, /* 0x34 4 */
     6, 1,      0x27, 0x45, 0x45, 0x45, 0x39, 0x00, /* 0x35 5 */
     6, 1,      0x3C, 0x4A, 0x49, 0x49, 0x30, 0x00, /* 0x36 6 */
     6, 1,      0x01, 0x71, 0x09, 0x05, 0x03, 0x00, /* 0x37 7 */
     6, 1,      0x36, 0x49, 0x49, 0x49, 0x36, 0x00, /* 0x38 8 */
     6, 1,      0x06, 0x49, 0x49, 0x29, 0x1E, 0x00, /* 0x39 9 */
     6, 1,      0x00, 0x36, 0x36, 0x00, 0x00, 0x00, /* 0x3A : */
     6, 1,      0x00, 0x56, 0x36, 0x00, 0x00, 0x00, /* 0x3B ; */
     6, 1,      0x08, 0x14, 0x22, 0x41, 0x00, 0x00, /* 0x3C < */
     6, 1,      0x14, 0x14, 0x14, 0x14, 0x14, 0x00, /* 0x3D = */
     6, 1,      0x00, 0x41, 0x22, 0x14, 0x08, 0x00, /* 0x3E > */
     6, 1,      0x02, 0x01, 0x51, 0x09, 0x06, 0x00, /* 0x3F ? */
     6, 1,      0x32, 0x49, 0x79, 0x41, 0x3E, 0x00, /* 0x40 @ */
     6, 1,      0x7E, 0x11, 0x11, 0x11, 0x7E, 0x00, /* 0x41 A */
     6, 1,      0x7F, 0x49, 0x49, 0x49, 0x36, 0x00, /* 0x42 B */
     6, 1,      0x3E, 0x41, 0x41, 0x41, 0x22, 0x00, /* 0x43 C */
     6, 1,      0x7F, 0x41, 0x41, 0x22, 0x1C, 0x00, /* 0x44 D */
     6, 1,      0x7F, 0x49, 0x49, 0x49, 0x41, 0x00, /* 0x45 E */
     6, 1,      0x7F, 0x09, 0x09, 0x09, 0x01, 0x00, /* 0x46 F */
     6, 1,      0x3E, 0x41, 0x49, 0x49, 0x7A, 0x00, /* 0x47 G */
     6, 1,      0x7F, 0x08, 0x08, 0x08, 0x7F, 0x00, /* 0x48 H */
     6, 1,      0x00, 0x41, 0x7F, 0x41, 0x00, 0x00, /* 0x49 I */
     6, 1,      0x20, 0x40, 0x41, 0x3F, 0x01, 0x00, /* 0x4A J */
     6, 1,      0x7F, 0x08, 0x14, 0x22, 0x41, 0x00, /* 0x4B K */
     6, 1,      0x7F, 0x40, 0x40, 0x40, 0x40, 0x00, /* 0x4C L */
     6, 1,      0x7F, 0x02, 0x0C, 0x02, 0x7F, 0x00, /* 0x4D M */
     6, 1,      0x7F, 0x04, 0x08, 0x10, 0x7F, 0x00, /* 0x4E N */
     6, 1,      0x3E, 0x41, 0x41, 0x41, 0x3E, 0x00, /* 0x4F O */
     6, 1,      0x7F, 0x09, 0x09, 0x09, 0x06, 0x00, /* 0x50 P */
     6, 1,      0x3E, 0x41, 0x51, 0x21, 0x5E, 0x00, /* 0x51 Q */
     6, 1,      0x7F, 0x09, 0x19, 0x29, 0x46, 0x00, /* 0x52 R */
     6, 1,      0x46, 0x49, 0x49, 0x49, 0x31, 0x00, /* 0x53 S */
     6, 1,      0x01, 0x01, 0x7F, 0x01, 0x01, 0x00, /* 0x54 T */
     6, 1,      0x3F, 0x40, 0x40, 0x40, 0x3F, 0x00, /* 0x55 U */
     6, 1,      0x1F, 0x20, 0x40, 0x20, 0x1F, 0x00, /* 0x56 V */
     6, 1,      0x3F, 0x40, 0x30, 0x40, 0x3F, 0x00, /* 0x57 W */
     6, 1,      0x63, 0x14, 0x08, 0x14, 0x63, 0x00, /* 0x58 X */
     6, 1,      0x07, 0x08, 0x70, 0x08, 0x07, 0x00, /* 0x59 Y */
     6, 1,      0x61, 0x51, 0x49, 0x45, 0x43, 0x00, /* 0x5A Z */
     6, 1,      0x7F, 0x41, 0x41, 0x00, 0x00, 0x00, /* 0x5B [ */
     6, 1,      0x02, 0x04, 0x08, 0x10, 0x20, 0x00, /* 0x5C \ */
     6, 1,      0x00, 0x00, 0x41, 0x41, 0x7F, 0x00, /* 0x5D ] */
     6, 1,      0x04, 0x02, 0x01, 0x02, 0x04, 0x00, /* 0x5E ^ */
     6, 1,      0x40, 0x40, 0x40, 0x40, 0x40, 0x00, /* 0x5F _ */
     6, 1,      0x00, 0x01, 0x02, 0x04, 0x00, 0x00, /* 0x60 ` */
     6, 1,      0x20, 0x54, 0x54, 0x54, 0x78, 0x00, /* 0x61 a */
     6, 1,      0x7F, 0x44, 0x44, 0x44, 0x38, 0x00, /* 0x62 b */
     6, 1,      0x38, 0x44, 0x44, 0x44, 0x44, 0x00, /* 0x63 c */
     6, 1,      0x38, 0x44, 0x44, 0x44, 0x7F, 0x00, /* 0x64 d */
     6, 1,      0x38, 0x54, 0x54, 0x54, 0x58, 0x00, /* 0x65 e */
     6, 1,      0x08, 0x7E, 0x09, 0x09, 0x02, 0x00, /* 0x66 f */
     6, 1,      0x18, 0xA4, 0xA4, 0xA4, 0x7C, 0x00, /* 0x67 g */
     6, 1,      0x7F, 0x04, 0x04, 0x04, 0x78, 0x00, /* 0x68 h */
     6, 1,      0x00, 0x44, 0x7D, 0x40, 0x00, 0x00, /* 0x69 i */
     6, 1,      0x20, 0x40, 0x40, 0x3D, 0x00, 0x00, /* 0x6A j */
     6, 1,      0x00, 0x7F, 0x10, 0x28, 0x44, 0x00, /* 0x6B k */
     6, 1,      0x00, 0x00, 0x41, 0x7F, 0x40, 0x00, /* 0x6C l */
     6, 1,      0x7C, 0x04, 0x38, 0x04, 0x78, 0x00, /* 0x6D m */
     6, 1,      0x7C, 0x08, 0x04, 0x04, 0x78, 0x00, /* 0x6E n */
     6, 1,      0x38, 0x44, 0x44, 0x44, 0x38, 0x00, /* 0x6F o */
     6, 1,      0xFC, 0x24, 0x24, 0x24, 0x18, 0x00, /* 0x70 p */
     6, 1,      0x18, 0x24, 0x24, 0x24, 0xFC, 0x00, /* 0x71 q */
     6, 1,      0x7C, 0x08, 0x04, 0x04, 0x08, 0x00, /* 0x72 r */
     6, 1,      0x48, 0x54, 0x54, 0x54, 0x24, 0x00, /* 0x73 s */
     6, 1,      0x04, 0x3F, 0x44, 0x44, 0x20, 0x00, /* 0x74 t */
     6, 1,      0x3C, 0x40, 0x40, 0x40, 0x3C, 0x00, /* 0x75 u */
     6, 1,      0x1C, 0x20, 0x40, 0x20, 0x1C, 0x00, /* 0x76 v */
     6, 1,      0x3C, 0x40, 0x30, 0x40, 0x3C, 0x00, /* 0x77 w */
     6, 1,      0x44, 0x28, 0x10, 0x28, 0x44, 0x00, /* 0x78 x */
     6, 1,      0x1C, 0xA0, 0xA0, 0xA0, 0x7C, 0x00, /* 0x79 y */
     6, 1,      0x44, 0x64, 0x54, 0x4C, 0x44, 0x00, /* 0x7A z */
     6, 1,      0x08, 0x36, 0x41, 0x41, 0x00, 0x00, /* 0x7B {  */
     6, 1,      0x00, 0x00, 0x77, 0x00, 0x00, 0x00, /* 0x7C | */
     6, 1,      0x00, 0x41, 0x41, 0x36, 0x08, 0x00, /* 0x7D } */
     6, 1,      0x08, 0x04, 0x04, 0x04, 0x02, 0x00, /* 0x7E ~ */
     6, 1,      0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, /* 0x7F   */
     6, 1,      0x40, 0x40, 0x40, 0x40, 0x40, 0x00, /* 0x80   */
     6, 1,      0x60, 0x60, 0x60, 0x60, 0x60, 0x00, /* 0x81   */
     6, 1,      0x70, 0x70, 0x70, 0x70, 0x70, 0x00, /* 0x82   */
     6, 1,      0x78, 0x78, 0x78, 0x78, 0x78, 0x00, /* 0x83   */
     6, 1,      0x7C, 0x7C, 0x7C, 0x7C, 0x7C, 0x00, /* 0x84   */
     6, 1,      0x7E, 0x7E, 0x7E, 0x7E, 0x7E, 0x00, /* 0x85   */
     6, 1,      0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x00, /* 0x86   */
     6, 1,      0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00, /* 0x87   */
     6, 1,      0x7F, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x88   */
     6, 1,      0x7F, 0x7F, 0x00, 0x00, 0x00, 0x00, /* 0x89   */
     6, 1,      0x7F, 0x7F, 0x7F, 0x00, 0x00, 0x00, /* 0x8A   */
     6, 1,      0x7F, 0x7F, 0x7F, 0x7F, 0x00, 0x00, /* 0x8B   */
     6, 1,      0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x00, /* 0x8C   */
     6, 1,      0x55, 0x2A, 0x55, 0x2A, 0x55, 0x00, /* 0x8D   */
     6, 1,      0xAA, 0x55, 0xAA, 0x55, 0xAA, 0x55, /* 0x8E   */
     6, 1,      0x10, 0x10, 0x10, 0xFF, 0x10, 0x10, /* 0x8F   */
     6, 1,      0x10, 0x10, 0x10, 0x1F, 0x10, 0x10, /* 0x90   */
     6, 1,      0x10, 0x10, 0x10, 0xF8, 0x10, 0x10, /* 0x91   */
     6, 1,      0x10, 0x10, 0x10, 0xFF, 0x00, 0x00, /* 0x92   */
     6, 1,      0x00, 0x00, 0x00, 0xFF, 0x10, 0x10, /* 0x93   */
     6, 1,      0x01, 0x01, 0x01, 0x01, 0x01, 0x01, /* 0x94   */
     6, 1,      0x10, 0x10, 0x10, 0x10, 0x10, 0x10, /* 0x95   */
     6, 1,      0x00, 0x00, 0x00, 0xFF, 0x00, 0x00, /* 0x96   */
     6, 1,      0x00, 0x00, 0x00, 0xF0, 0x10, 0x10, /* 0x97   */
     6, 1,      0x10, 0x10, 0x10, 0xF0, 0x00, 0x00, /* 0x98   */
     6, 1,      0x00, 0x00, 0x00, 0x1F, 0x10, 0x10, /* 0x99   */
     6, 1,      0x10, 0x10, 0x10, 0x1F, 0x00, 0x00, /* 0x9A   */
     6, 1,      0x00, 0x00, 0x00, 0xE0, 0x10, 0x10, /* 0x9B   */
     6, 1,      0x10, 0x10, 0x20, 0xC0, 0x00, 0x00, /* 0x9C   */
     6, 1,      0x00, 0x00, 0x00, 0x0F, 0x10, 0x10, /* 0x9D   */
     6, 1,      0x20, 0x20, 0x10, 0x0F, 0x00, 0x00, /* 0x9E   */
     6, 1,      0x78, 0x15, 0x14, 0x15, 0x78, 0x00, /* 0x9F   */
     6, 1,      0x78, 0x14, 0x15, 0x14, 0x78, 0x00, /* 0xA0   */
     6, 1,      0x78, 0x14, 0x16, 0x15, 0x78, 0x00, /* 0xA1   */
     6, 1,      0x0E, 0x51, 0x31, 0x11, 0x11, 0x00, /* 0xA2   */
     6, 1,      0x78, 0x16, 0x15, 0x16, 0x78, 0x00, /* 0xA3   */
     6, 1,      0x7E, 0x09, 0x7E, 0x4A, 0x4A, 0x00, /* 0xA4   */
     6, 1,      0x7C, 0x54, 0x56, 0x55, 0x44, 0x00, /* 0xA5   */
     6, 1,      0x7C, 0x55, 0x56, 0x54, 0x44, 0x00, /* 0xA6   */
     6, 1,      0x7C, 0x56, 0x55, 0x56, 0x44, 0x00, /* 0xA7   */
     6, 1,      0x00, 0x45, 0x7C, 0x45, 0x00, 0x00, /* 0xA8   */
     6, 1,      0x00, 0x44, 0x7E, 0x45, 0x00, 0x00, /* 0xA9   */
     6, 1,      0x00, 0x45, 0x7E, 0x44, 0x00, 0x00, /* 0xAA   */
     6, 1,      0x00, 0x46, 0x7D, 0x46, 0x00, 0x00, /* 0xAB   */
     6, 1,      0x38, 0x45, 0x44, 0x45, 0x38, 0x00, /* 0xAC   */
     6, 1,      0x7A, 0x09, 0x13, 0x22, 0x79, 0x00, /* 0xAD   */
     6, 1,      0x3E, 0x51, 0x49, 0x45, 0x3E, 0x00, /* 0xAE   */
     6, 1,      0x38, 0x44, 0x46, 0x45, 0x38, 0x00, /* 0xAF   */
     6, 1,      0x38, 0x45, 0x46, 0x44, 0x38, 0x00, /* 0xB0   */
     6, 1,      0x78, 0x15, 0x16, 0x14, 0x78, 0x00, /* 0xB1   */
     6, 1,      0xFF, 0x01, 0x01, 0x49, 0x36, 0x00, /* 0xB2   */
     6, 1,      0x7C, 0x55, 0x54, 0x55, 0x44, 0x00, /* 0xB3   */
     6, 1,      0x3C, 0x41, 0x40, 0x41, 0x3C, 0x00, /* 0xB4   */
     6, 1,      0x3C, 0x40, 0x42, 0x41, 0x3C, 0x00, /* 0xB5   */
     6, 1,      0x3C, 0x41, 0x42, 0x40, 0x3C, 0x00, /* 0xB6   */
     6, 1,      0x3C, 0x42, 0x41, 0x42, 0x3C, 0x00, /* 0xB7   */
     6, 1,      0x00, 0x02, 0x05, 0x02, 0x00, 0x00, /* 0xB8   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xB9   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xBA   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xBB   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xBC   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xBD   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xBE   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xBF   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xC0   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xC1   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xC2   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xC3   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xC4   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xC5   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xC6   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xC7   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xC8   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xC9   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xCA   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xCB   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xCC   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xCD   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xCE   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xCF   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xD0   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xD1   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xD2   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xD3   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xD4   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xD5   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xD6   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xD7   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xD8   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xD9   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xDA   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xDB   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xDC   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xDD   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xDE   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xDF   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xE0   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xE1   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xE2   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xE3   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xE4   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xE5   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xE6   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xE7   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xE8   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xE9   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xEA   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xEB   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xEC   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xED   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xEE   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xEF   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xF0   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xF1   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xF2   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xF3   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xF4   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xF5   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xF6   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xF7   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xF8   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xF9   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xFA   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xFB   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xFC   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xFD   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xFE   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00  /* 0xFF   */
};  


char VFD_ProportionalFont[] =
// ----------------------------------------------------------------------------
//   The proportional font for the VFD
// ----------------------------------------------------------------------------
{
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x00   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x01   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x02   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x03   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x04   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x05   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x06   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x07   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x08   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x09   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x0A   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x0B   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x0C   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x0D   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x0E   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x0F   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x10   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x11   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x12   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x13   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x14   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x15   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x16   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x17   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x18   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x19   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x1A   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x1B   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x1C   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x1D   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x1E   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x1F   */
     3, 1,      0x00, 0x00, 0x00,                   /* 0x20   */
     3, 1,      0x00, 0x5F, 0x00,                   /* 0x21 ! */
     5, 1,      0x00, 0x0E, 0x00, 0x0E, 0x00,       /* 0x22 " */
     6, 1,      0x14, 0x7F, 0x14, 0x7F, 0x14, 0x00, /* 0x23 # */
     6, 1,      0x24, 0x2A, 0x7F, 0x2A, 0x12, 0x00, /* 0x24 $ */
     6, 1,      0x46, 0x26, 0x10, 0x68, 0x64, 0x00, /* 0x25 % */
     6, 1,      0x36, 0x49, 0x55, 0x22, 0x50, 0x00, /* 0x26 & */
     4, 1,      0x00, 0x0A, 0x06, 0x00,             /* 0x27 ' */
     5, 1,      0x00, 0x1C, 0x22, 0x41, 0x00,       /* 0x28 ( */
     5, 1,      0x00, 0x41, 0x22, 0x1C, 0x00,       /* 0x29 ) */
     6, 1,      0x28, 0x10, 0x7C, 0x10, 0x28, 0x00, /* 0x2A * */
     6, 1,      0x08, 0x08, 0x3E, 0x08, 0x08, 0x00, /* 0x2B + */
     4, 1,      0x00, 0x50, 0x30, 0x00,             /* 0x2C , */
     6, 1,      0x08, 0x08, 0x08, 0x08, 0x08, 0x00, /* 0x2D - */
     4, 1,      0x00, 0x60, 0x60, 0x00,             /* 0x2E . */
     6, 1,      0x40, 0x20, 0x10, 0x08, 0x04, 0x00, /* 0x2F / */
     6, 1,      0x3E, 0x51, 0x49, 0x45, 0x3E, 0x00, /* 0x30 0 */
     6, 1,      0x00, 0x42, 0x7F, 0x40, 0x00, 0x00, /* 0x31 1 */
     6, 1,      0x42, 0x61, 0x51, 0x49, 0x46, 0x00, /* 0x32 2 */
     6, 1,      0x21, 0x41, 0x45, 0x4B, 0x31, 0x00, /* 0x33 3 */
     6, 1,      0x18, 0x14, 0x12, 0x7F, 0x10, 0x00, /* 0x34 4 */
     6, 1,      0x27, 0x45, 0x45, 0x45, 0x39, 0x00, /* 0x35 5 */
     6, 1,      0x3C, 0x4A, 0x49, 0x49, 0x30, 0x00, /* 0x36 6 */
     6, 1,      0x01, 0x71, 0x09, 0x05, 0x03, 0x00, /* 0x37 7 */
     6, 1,      0x36, 0x49, 0x49, 0x49, 0x36, 0x00, /* 0x38 8 */
     6, 1,      0x06, 0x49, 0x49, 0x29, 0x1E, 0x00, /* 0x39 9 */
     4, 1,      0x00, 0x36, 0x36, 0x00,             /* 0x3A : */
     4, 1,      0x00, 0x56, 0x36, 0x00,             /* 0x3B ; */
     6, 1,      0x08, 0x14, 0x22, 0x41, 0x00, 0x00, /* 0x3C < */
     6, 1,      0x14, 0x14, 0x14, 0x14, 0x14, 0x00, /* 0x3D = */
     6, 1,      0x00, 0x41, 0x22, 0x14, 0x08, 0x00, /* 0x3E > */
     6, 1,      0x02, 0x01, 0x51, 0x09, 0x06, 0x00, /* 0x3F ? */
     6, 1,      0x32, 0x49, 0x79, 0x41, 0x3E, 0x00, /* 0x40 @ */
     6, 1,      0x7E, 0x11, 0x11, 0x11, 0x7E, 0x00, /* 0x41 A */
     6, 1,      0x7F, 0x49, 0x49, 0x49, 0x36, 0x00, /* 0x42 B */
     6, 1,      0x3E, 0x41, 0x41, 0x41, 0x22, 0x00, /* 0x43 C */
     6, 1,      0x7F, 0x41, 0x41, 0x22, 0x1C, 0x00, /* 0x44 D */
     6, 1,      0x7F, 0x49, 0x49, 0x49, 0x41, 0x00, /* 0x45 E */
     6, 1,      0x7F, 0x09, 0x09, 0x09, 0x01, 0x00, /* 0x46 F */
     6, 1,      0x3E, 0x41, 0x49, 0x49, 0x7A, 0x00, /* 0x47 G */
     6, 1,      0x7F, 0x08, 0x08, 0x08, 0x7F, 0x00, /* 0x48 H */
     5, 1,      0x41, 0x7F, 0x41, 0x00, 0x00,       /* 0x49 I */
     6, 1,      0x20, 0x40, 0x41, 0x3F, 0x01, 0x00, /* 0x4A J */
     6, 1,      0x7F, 0x08, 0x14, 0x22, 0x41, 0x00, /* 0x4B K */
     6, 1,      0x7F, 0x40, 0x40, 0x40, 0x40, 0x00, /* 0x4C L */
     6, 1,      0x7F, 0x02, 0x0C, 0x02, 0x7F, 0x00, /* 0x4D M */
     6, 1,      0x7F, 0x04, 0x08, 0x10, 0x7F, 0x00, /* 0x4E N */
     6, 1,      0x3E, 0x41, 0x41, 0x41, 0x3E, 0x00, /* 0x4F O */
     6, 1,      0x7F, 0x09, 0x09, 0x09, 0x06, 0x00, /* 0x50 P */
     6, 1,      0x3E, 0x41, 0x51, 0x21, 0x5E, 0x00, /* 0x51 Q */
     6, 1,      0x7F, 0x09, 0x19, 0x29, 0x46, 0x00, /* 0x52 R */
     6, 1,      0x46, 0x49, 0x49, 0x49, 0x31, 0x00, /* 0x53 S */
     6, 1,      0x01, 0x01, 0x7F, 0x01, 0x01, 0x00, /* 0x54 T */
     6, 1,      0x3F, 0x40, 0x40, 0x40, 0x3F, 0x00, /* 0x55 U */
     6, 1,      0x1F, 0x20, 0x40, 0x20, 0x1F, 0x00, /* 0x56 V */
     6, 1,      0x3F, 0x40, 0x30, 0x40, 0x3F, 0x00, /* 0x57 W */
     6, 1,      0x63, 0x14, 0x08, 0x14, 0x63, 0x00, /* 0x58 X */
     6, 1,      0x07, 0x08, 0x70, 0x08, 0x07, 0x00, /* 0x59 Y */
     6, 1,      0x61, 0x51, 0x49, 0x45, 0x43, 0x00, /* 0x5A Z */
     4, 1,      0x7F, 0x41, 0x41, 0x00,             /* 0x5B [ */
     6, 1,      0x02, 0x04, 0x08, 0x10, 0x20, 0x00, /* 0x5C \ */
     4, 1,      0x41, 0x41, 0x7F, 0x00,             /* 0x5D ] */
     6, 1,      0x04, 0x02, 0x01, 0x02, 0x04, 0x00, /* 0x5E ^ */
     6, 1,      0x40, 0x40, 0x40, 0x40, 0x40, 0x00, /* 0x5F _ */
     4, 1,      0x01, 0x02, 0x04, 0x00,             /* 0x60 ` */
     6, 1,      0x20, 0x54, 0x54, 0x54, 0x78, 0x00, /* 0x61 a */
     6, 1,      0x7F, 0x44, 0x44, 0x44, 0x38, 0x00, /* 0x62 b */
     6, 1,      0x38, 0x44, 0x44, 0x44, 0x44, 0x00, /* 0x63 c */
     6, 1,      0x38, 0x44, 0x44, 0x44, 0x7F, 0x00, /* 0x64 d */
     6, 1,      0x38, 0x54, 0x54, 0x54, 0x58, 0x00, /* 0x65 e */
     6, 1,      0x08, 0x7E, 0x09, 0x09, 0x02, 0x00, /* 0x66 f */
     6, 1,      0x18, 0xA4, 0xA4, 0xA4, 0x7C, 0x00, /* 0x67 g */
     6, 1,      0x7F, 0x04, 0x04, 0x04, 0x78, 0x00, /* 0x68 h */
     4, 1,      0x44, 0x7D, 0x40, 0x00,             /* 0x69 i */
     6, 1,      0x20, 0x40, 0x40, 0x3D, 0x00, 0x00, /* 0x6A j */
     6, 1,      0x00, 0x7F, 0x10, 0x28, 0x44, 0x00, /* 0x6B k */
     4, 1,      0x41, 0x7F, 0x40, 0x00,             /* 0x6C l */
     8, 1,      0x7C, 0x04, 0x04, 0x38, 0x04, 0x04, 0x78, 0x00, /* 0x6D m */
     6, 1,      0x7C, 0x08, 0x04, 0x04, 0x78, 0x00, /* 0x6E n */
     6, 1,      0x38, 0x44, 0x44, 0x44, 0x38, 0x00, /* 0x6F o */
     6, 1,      0xFC, 0x24, 0x24, 0x24, 0x18, 0x00, /* 0x70 p */
     6, 1,      0x18, 0x24, 0x24, 0x24, 0xFC, 0x00, /* 0x71 q */
     6, 1,      0x7C, 0x08, 0x04, 0x04, 0x08, 0x00, /* 0x72 r */
     6, 1,      0x48, 0x54, 0x54, 0x54, 0x24, 0x00, /* 0x73 s */
     6, 1,      0x04, 0x3F, 0x44, 0x44, 0x20, 0x00, /* 0x74 t */
     6, 1,      0x3C, 0x40, 0x40, 0x40, 0x3C, 0x00, /* 0x75 u */
     6, 1,      0x1C, 0x20, 0x40, 0x20, 0x1C, 0x00, /* 0x76 v */
     8, 1,      0x3C, 0x40, 0x40, 0x30, 0x40, 0x40, 0x3C, 0x00, /* 0x77 w */
     6, 1,      0x44, 0x28, 0x10, 0x28, 0x44, 0x00, /* 0x78 x */
     6, 1,      0x1C, 0xA0, 0xA0, 0xA0, 0x7C, 0x00, /* 0x79 y */
     6, 1,      0x44, 0x64, 0x54, 0x4C, 0x44, 0x00, /* 0x7A z */
     6, 1,      0x08, 0x36, 0x41, 0x41, 0x00, 0x00, /* 0x7B {  */
     6, 1,      0x00, 0x00, 0x77, 0x00, 0x00, 0x00, /* 0x7C | */
     6, 1,      0x00, 0x41, 0x41, 0x36, 0x08, 0x00, /* 0x7D } */
     6, 1,      0x08, 0x04, 0x04, 0x04, 0x02, 0x00, /* 0x7E ~ */
     6, 1,      0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, /* 0x7F   */
     6, 1,      0x40, 0x40, 0x40, 0x40, 0x40, 0x00, /* 0x80   */
     6, 1,      0x60, 0x60, 0x60, 0x60, 0x60, 0x00, /* 0x81   */
     6, 1,      0x70, 0x70, 0x70, 0x70, 0x70, 0x00, /* 0x82   */
     6, 1,      0x78, 0x78, 0x78, 0x78, 0x78, 0x00, /* 0x83   */
     6, 1,      0x7C, 0x7C, 0x7C, 0x7C, 0x7C, 0x00, /* 0x84   */
     6, 1,      0x7E, 0x7E, 0x7E, 0x7E, 0x7E, 0x00, /* 0x85   */
     6, 1,      0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x00, /* 0x86   */
     6, 1,      0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00, /* 0x87   */
     6, 1,      0x7F, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0x88   */
     6, 1,      0x7F, 0x7F, 0x00, 0x00, 0x00, 0x00, /* 0x89   */
     6, 1,      0x7F, 0x7F, 0x7F, 0x00, 0x00, 0x00, /* 0x8A   */
     6, 1,      0x7F, 0x7F, 0x7F, 0x7F, 0x00, 0x00, /* 0x8B   */
     6, 1,      0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x00, /* 0x8C   */
     6, 1,      0x55, 0x2A, 0x55, 0x2A, 0x55, 0x00, /* 0x8D   */
     6, 1,      0xAA, 0x55, 0xAA, 0x55, 0xAA, 0x55, /* 0x8E   */
     6, 1,      0x10, 0x10, 0x10, 0xFF, 0x10, 0x10, /* 0x8F   */
     6, 1,      0x10, 0x10, 0x10, 0x1F, 0x10, 0x10, /* 0x90   */
     6, 1,      0x10, 0x10, 0x10, 0xF8, 0x10, 0x10, /* 0x91   */
     6, 1,      0x10, 0x10, 0x10, 0xFF, 0x00, 0x00, /* 0x92   */
     6, 1,      0x00, 0x00, 0x00, 0xFF, 0x10, 0x10, /* 0x93   */
     6, 1,      0x01, 0x01, 0x01, 0x01, 0x01, 0x01, /* 0x94   */
     6, 1,      0x10, 0x10, 0x10, 0x10, 0x10, 0x10, /* 0x95   */
     6, 1,      0x00, 0x00, 0x00, 0xFF, 0x00, 0x00, /* 0x96   */
     6, 1,      0x00, 0x00, 0x00, 0xF0, 0x10, 0x10, /* 0x97   */
     6, 1,      0x10, 0x10, 0x10, 0xF0, 0x00, 0x00, /* 0x98   */
     6, 1,      0x00, 0x00, 0x00, 0x1F, 0x10, 0x10, /* 0x99   */
     6, 1,      0x10, 0x10, 0x10, 0x1F, 0x00, 0x00, /* 0x9A   */
     6, 1,      0x00, 0x00, 0x00, 0xE0, 0x10, 0x10, /* 0x9B   */
     6, 1,      0x10, 0x10, 0x20, 0xC0, 0x00, 0x00, /* 0x9C   */
     6, 1,      0x00, 0x00, 0x00, 0x0F, 0x10, 0x10, /* 0x9D   */
     6, 1,      0x20, 0x20, 0x10, 0x0F, 0x00, 0x00, /* 0x9E   */
     6, 1,      0x78, 0x15, 0x14, 0x15, 0x78, 0x00, /* 0x9F   */
     6, 1,      0x78, 0x14, 0x15, 0x14, 0x78, 0x00, /* 0xA0   */
     6, 1,      0x78, 0x14, 0x16, 0x15, 0x78, 0x00, /* 0xA1   */
     6, 1,      0x0E, 0x51, 0x31, 0x11, 0x11, 0x00, /* 0xA2   */
     6, 1,      0x78, 0x16, 0x15, 0x16, 0x78, 0x00, /* 0xA3   */
     6, 1,      0x7E, 0x09, 0x7E, 0x4A, 0x4A, 0x00, /* 0xA4   */
     6, 1,      0x7C, 0x54, 0x56, 0x55, 0x44, 0x00, /* 0xA5   */
     6, 1,      0x7C, 0x55, 0x56, 0x54, 0x44, 0x00, /* 0xA6   */
     6, 1,      0x7C, 0x56, 0x55, 0x56, 0x44, 0x00, /* 0xA7   */
     6, 1,      0x00, 0x45, 0x7C, 0x45, 0x00, 0x00, /* 0xA8   */
     6, 1,      0x00, 0x44, 0x7E, 0x45, 0x00, 0x00, /* 0xA9   */
     6, 1,      0x00, 0x45, 0x7E, 0x44, 0x00, 0x00, /* 0xAA   */
     6, 1,      0x00, 0x46, 0x7D, 0x46, 0x00, 0x00, /* 0xAB   */
     6, 1,      0x38, 0x45, 0x44, 0x45, 0x38, 0x00, /* 0xAC   */
     6, 1,      0x7A, 0x09, 0x13, 0x22, 0x79, 0x00, /* 0xAD   */
     6, 1,      0x3E, 0x51, 0x49, 0x45, 0x3E, 0x00, /* 0xAE   */
     6, 1,      0x38, 0x44, 0x46, 0x45, 0x38, 0x00, /* 0xAF   */
     6, 1,      0x38, 0x45, 0x46, 0x44, 0x38, 0x00, /* 0xB0   */
     6, 1,      0x78, 0x15, 0x16, 0x14, 0x78, 0x00, /* 0xB1   */
     6, 1,      0xFF, 0x01, 0x01, 0x49, 0x36, 0x00, /* 0xB2   */
     6, 1,      0x7C, 0x55, 0x54, 0x55, 0x44, 0x00, /* 0xB3   */
     6, 1,      0x3C, 0x41, 0x40, 0x41, 0x3C, 0x00, /* 0xB4   */
     6, 1,      0x3C, 0x40, 0x42, 0x41, 0x3C, 0x00, /* 0xB5   */
     6, 1,      0x3C, 0x41, 0x42, 0x40, 0x3C, 0x00, /* 0xB6   */
     6, 1,      0x3C, 0x42, 0x41, 0x42, 0x3C, 0x00, /* 0xB7   */
     6, 1,      0x00, 0x02, 0x05, 0x02, 0x00, 0x00, /* 0xB8   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xB9   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xBA   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xBB   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xBC   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xBD   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xBE   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xBF   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xC0   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xC1   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xC2   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xC3   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xC4   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xC5   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xC6   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xC7   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xC8   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xC9   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xCA   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xCB   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xCC   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xCD   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xCE   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xCF   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xD0   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xD1   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xD2   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xD3   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xD4   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xD5   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xD6   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xD7   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xD8   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xD9   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xDA   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xDB   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xDC   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xDD   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xDE   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xDF   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xE0   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xE1   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xE2   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xE3   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xE4   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xE5   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xE6   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xE7   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xE8   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xE9   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xEA   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xEB   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xEC   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xED   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xEE   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xEF   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xF0   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xF1   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xF2   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xF3   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xF4   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xF5   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xF6   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xF7   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xF8   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xF9   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xFA   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xFB   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xFC   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xFD   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* 0xFE   */
     6, 1,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00  /* 0xFF   */
};  


int VFD_IsFont(char *ptr)
// ----------------------------------------------------------------------------
//   Return true if the pointer is a pre-defined font
// ----------------------------------------------------------------------------
{
#define ISFNT(fname) (ptr >= fname && ptr <= fname + sizeof(fname))
    return ISFNT(VFD_ProportionalFont) || ISFNT(VFD_MonospacedFont);
}
